#include <algorithm>
#include <vector>
#include <cstdio>

struct t_point { long long x, y; };

long test(t_point *p, long n, long a, long b, long c) {
	long ans = 0;
	//Особый случай, когда треугольник вырождается в отрезок:
	if (((p[c].x == p[a].x) && (p[c].y == p[a].y)) || ((p[c].x == p[b].x) && (p[c].y == p[b].y))) {
		//...
		long long dx1 = p[b].x - p[a].x, dy1 = p[b].y - p[a].y;
		long long dx2 = p[c].x - p[a].x, dy2 = p[c].y - p[a].y;
		long long max = std::max(dx1 * dx1 + dy1 * dy1, dx1 * dx2 + dy1 * dy2);
		long long min = std::min(0LL, dx1 * dx2 + dy1 * dy2);
		for (long i = 0; i < n; ++ i) {
			long long dx = p[i].x - p[a].x, dy = p[i].y - p[a].y;
			long long d = dx * dx1 + dy * dy1;
			if (dx * dy1 - dy * dx1 != 0) continue;	//NOTE: Учитываем только точки, лежащие на одной прямой с заданным отрезком!
			ans += ((min <= d) && (d <= max));
		}
		//...
		return ans;
	}
	for (long i = 0; i < n; ++ i) {
		bool use = true;
		for (long k = 0; k < 3; ++ k) {
			long long dx1 = p[b].x - p[a].x, dy1 = p[b].y - p[a].y;
			long long dx2 = p[c].x - p[a].x, dy2 = p[c].y - p[a].y;
			long long dir = (dx2 * dy1 - dy2 * dx1 < 0)? (-1): (1);
			//...
			long long dx = p[i].x - p[a].x, dy = p[i].y - p[a].y;
			use = use && ((dx * dy1 - dy * dx1) * dir >= 0);
			//shuffle:
			long t = c; c = b; b = a; a = t;
		}
		ans += use;
	}
	return ans;
}

#define ERR_OK (0)
#define ERR_WA (1)
#define ERR_PE (2)
#define ERR_UH (3)

int main(int argc, char *argv[]) {
	//...
	std::vector<t_point> point; long num; FILE *fid = fopen(argv[1], "rt");
	fscanf(fid, "%lu", &num); point.resize(num + 2);
	for (long i = 0; i < num + 2; ++ i) {
		fscanf(fid, "%lli %lli", &point[i].x, &point[i].y);
	}
	fclose(fid);
	//...
	long a = num, b = num + 1, c1, c2;
	//...
	fid = fopen(argv[3], "rt");
	fscanf(fid, "%lu", &c1);
	fclose(fid);
	//...
	if ((fid = fopen(argv[2], "rt")) == NULL) {
		printf("Output file not found!\n"); return ERR_PE;
	}
	if (!fscanf(fid, "%li", &c2)) {
		printf("Incorrect format!\n"); return ERR_PE;
	}
	if ((c2 >= num) || (c2 < 0)) {
		printf("Incorrect index!\n"); return ERR_WA;
	}
	fclose(fid);
	//...
	long n1 = test(
		point.data(), num, a, b, c1
	);
	long n2 = test(
		point.data(), num, a, b, c2
	);
	if (n1 > n2) {
		printf("Answer of contestant is not optimal!\n");
		return ERR_WA;
	}
	if (n1 < n2) {
		printf("Answer of jury is not optimal!\n");
		return ERR_UH;
	}
	//...
	return ERR_OK;
}
