#include <algorithm>
#include <vector>
#include <cstdio>

struct t_point { long long x, y; };

//Определяет число точек, попадающих в заданный треугольник:
long test(t_point *p, long n, long a, long b, long c) {
	long ans = 0;
	//Особый случай, когда треугольник вырождается в отрезок:
	if (((p[c].x == p[a].x) && (p[c].y == p[a].y)) || ((p[c].x == p[b].x) && (p[c].y == p[b].y))) {
		//...
		long long dx1 = p[b].x - p[a].x, dy1 = p[b].y - p[a].y;
		long long dx2 = p[c].x - p[a].x, dy2 = p[c].y - p[a].y;
		long long max = std::max(dx1 * dx1 + dy1 * dy1, dx1 * dx2 + dy1 * dy2);
		long long min = std::min(0LL, dx1 * dx2 + dy1 * dy2);
		for (long i = 0; i < n; ++ i) {
			long long dx = p[i].x - p[a].x, dy = p[i].y - p[a].y;
			long long d = dx * dx1 + dy * dy1;
			if (dx * dy1 - dy * dx1 != 0) continue;	//NOTE: Учитываем только точки, лежащие на одной прямой с заданным отрезком!
			ans += ((min <= d) && (d <= max));
		}
		//...
		return ans;
	}
	for (long i = 0; i < n; ++ i) {
		bool use = true;
		for (long k = 0; k < 3; ++ k) {
			long long dx1 = p[b].x - p[a].x, dy1 = p[b].y - p[a].y;
			long long dx2 = p[c].x - p[a].x, dy2 = p[c].y - p[a].y;
			long long dir = (dx2 * dy1 - dy2 * dx1 < 0)? (-1): (1);
			//...
			long long dx = p[i].x - p[a].x, dy = p[i].y - p[a].y;
			use = use && ((dx * dy1 - dy * dx1) * dir >= 0);
			//shuffle:
			long t = c; c = b; b = a; a = t;
		}
		ans += use;
	}
	return ans;
}

int main() {
	//...
	std::vector<t_point> point; long num;
	FILE *fid = fopen("input.txt", "rt");
	fscanf(fid, "%lu", &num);
	point.resize(num + 2);
	for (long i = 0; i < num + 2; ++ i) {
		fscanf(fid, "%lli %lli", &point[i].x, &point[i].y);
	}
	fclose(fid);
	//...
	long s0 = -1, c0, a = num, b = num + 1;
	for (long c = 0; c < num; ++ c) {
		long s = test(point.data(), num, a, b, c);
		if (s > s0) { s0 = s; c0 = c; }
	}
	//...
	fid = fopen("output.txt", "wt");
	fprintf(fid, "%lu", c0);
	fclose(fid);
	//...
	return 0;
}
